##########################################
#           Flags	                 #
##########################################

# Compiler options
CC=riscv64-unknown-linux-gnu-gcc
CFLAGS=-c -mcmodel=medany #-march=rv64ima -mabi=lp64 # -Wall
LIB=
LDFLAGS= -mcmodel=medany
EXECUTABLE_NAME=enhance
INC=-Iinclude
# Folders
BIN=build

#########################################################
# Rules 						#
#########################################################
LINK_OPTS ?= -static -nostartfiles -lm -lgcc -T spike.lds
EXECUTABLE_FILES = $(EXECUTABLE_NAME:%=$(BIN)/%)
OBJECT_FILES_C   = $(patsubst %.c, $(BIN)/%.o, $(wildcard *.c))
OBJECT_FILES_S   = $(patsubst %.S, $(BIN)/%.o,  $(wildcard *.S))
# ^^^ A more succinct expression for $(OBJECT_FILES), using
#     http://www.gnu.org/software/make/manual/make.html#Substitution-Refs

all: $(EXECUTABLE_FILES)

clean:
	rm -r -f $(BIN)	

# http://www.gnu.org/software/make/manual/make.html#Phony-Targets
.PHONY: build clean
#
$(EXECUTABLE_FILES): $(OBJECT_FILES_C) $(OBJECT_FILES_S)
	@$(CC) $(LDFLAGS) -o $@ $^ $(LIB) $(LINK_OPTS)
	@# ^^^ http://www.gnu.org/software/make/manual/make.html#Automatic-Variables
	@echo "Build successful!"

# http://www.gnu.org/software/make/manual/make.html#Static-Pattern
$(OBJECT_FILES_C): $(BIN)/%.o: %.c
	@echo Compiling $<	
	@mkdir -p $(@D)	
	@$(CC) $(CFLAGS) $(INC) -o $@ $<

$(OBJECT_FILES_S): $(BIN)/%.o: %.S
	@echo Compiling $<	
	@mkdir -p $(@D)	
	@$(CC) $(CFLAGS) $(INC) -o $@ $<




